//+------------------------------------------------------------------+
//|                  Advanced Volume MA Cross Expert V7 by Johan.mq4 |
//|                                                   Johan Korthout |
//|                                  http://www.korthoutsoftware.com |
//+------------------------------------------------------------------+
//Preprocessor
#property copyright "Johan Korthout"
#property link      "http://www.korthoutsoftware.com"
#include <IncludeAVMA.mqh>

//External variables
extern string Expert_Advisor = "Advanced Volume MA Cross EA V7 by Johan";
extern bool DynamicLotSize = false;
extern double EquityPercent = 2;
extern double FixedLotSize = 1;

extern double StopLoss = 0;
extern double TakeProfit = 100;

extern int TrailingStop = 20;
extern int MinimumProfit = 50;
extern int Slippage = 3;
extern int MagicNumber = 280269;
extern int FastMAPeriod = 3;
extern int SlowMAPeriod = 6;
extern bool CheckOncePerBar = false;
extern string VolumeFilterSetting = "Volume Filter Settings";
extern bool VolumeFilter = true;
extern bool ManualVolumeFilterON = true;
extern int MinimalVolume = 380;
extern string Notify_Settings = "Set Alerts and/or Email";
extern int SoundON=1;
extern int EmailON=1;

extern string SetTradingDays = "Set Trading Days";
extern bool TradeMonday = true;
extern bool TradeTuesday = true;
extern bool TradeWednesday = true;
extern bool TradeThursday = true;
extern bool TradeFriday = false;
extern bool TradeSunday = false;

extern string TimerSettings = "Set Trade Times";
extern bool UseTimer = true;
extern bool UseLocalTime = true;

extern string Trade_frame_1;
extern int StartHour1 = 6;
extern int StartMinute1 = 0;
extern int EndHour1 = 13;
extern int EndMinute1 = 0;

extern string Trade_frame_2;
extern int StartHour2 = 15;
extern int StartMinute2 = 0;
extern int EndHour2 = 23;
extern int EndMinute2 = 0;

extern string Trade_frame_3;
extern int StartHour3 = 1;
extern int StartMinute3 = 0;
extern int EndHour3 = 4;
extern int EndMinute3 = 0;

extern string Trade_frame_4;
extern int StartHour4 = 23;
extern int StartMinute4 = 58;
extern int EndHour4 = 23;
extern int EndMinute4 = 59;

extern string Trade_frame_5;
extern int StartHour5 = 23;
extern int StartMinute5 = 58;
extern int EndHour5 = 23;
extern int EndMinute5 = 59;

// News variables
extern string News_Time = "Enter News times";
string News_frame_1;
extern int NewsStartHour1 = 12;
extern int NewsStartMinute1 = 30;
extern int NewsEndHour1 = 13;
extern int NewsEndMinute1 = 30;

extern string News_frame_2;
extern int NewsStartHour2 = 4;
extern int NewsStartMinute2 = 58;
extern int NewsEndHour2 = 4;
extern int NewsEndMinute2 = 59;

extern string News_frame_3;
extern int NewsStartHour3 = 4;
extern int NewsStartMinute3 = 58;
extern int NewsEndHour3 = 4;
extern int NewsEndMinute3 = 59;

extern string News_frame_4;
extern int NewsStartHour4 = 4;
extern int NewsStartMinute4 = 58;
extern int NewsEndHour4 = 4;
extern int NewsEndMinute4 = 59;

extern string News_frame_5;
extern int NewsStartHour5 = 4;
extern int NewsStartMinute5 = 58;
extern int NewsEndHour5 = 4;
extern int NewsEndMinute5 = 59;

extern string CloseAllOrders = "Close Orders Outside Trading Hours";
extern bool CloseAllTheOrders = true;

//Global variables
int BuyTicket;
int SellTicket;

double UsePoint;
int UseSlippage;

datetime CurrentTimeStamp;
double FastMA;
double SlowMA;
double LastFastMA;
double LastSlowMA;
double minvolume1 = 50;
static int AantalDigits;
static int multiplier = 1000;
bool TradeAllowed = true;
bool NewsTime = false;
double CurrentSpread = 0;
bool DayNotAllowed = false;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
UsePoint = PipPoint(Symbol());
UseSlippage = GetSlippage(Symbol(),Slippage);

CurrentTimeStamp = Time[0];
//----
 }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//Calculate spread
CurrentSpread = (Ask - Bid);
CurrentSpread /= PipPoint(Symbol());
//Calculate LotSize..
 double LotSize = CalcLotSize(DynamicLotSize,EquityPercent,StopLoss,FixedLotSize);
 LotSize = VerifyLotSize(LotSize);
//Hieronder de comments adhv Email on setting en timer setting (TradeAllowed)...
if (EmailON==0 && TradeAllowed==false) Comment("      OUT OF SESSION - NO TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      Website: www.korthoutsoftware.com",
"\n","      EmailON=0; NO emails are being sent out...!!",
"\n","      Huidige volume currency: ", iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",CurrentSpread,
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "      Balance                : ", AccountBalance(),
"\n", "      Equity                 : ", AccountEquity(), 
"\n", "      Orders Total         : ", OrdersTotal(), 
"\n", "      Total Profit/Loss    : ", AccountProfit(), 
"\n", "      Orders Lot Size       : ", OrderLots(), 
"\n", "      Next Lot Size         : ", LotSize,
"\n");


if (EmailON==0 && TradeAllowed==true) Comment("      IN SESSION - TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      Website: www.korthoutsoftware.com",
"\n","      EmailON=0; NO emails are being sent out...!!",
"\n","      Huidige volume currency: ", iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",CurrentSpread,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "      Balance                : ", AccountBalance(),
"\n", "      Equity                 : ", AccountEquity(), 
"\n", "      Orders Total         : ", OrdersTotal(), 
"\n", "      Total Profit/Loss    : ", AccountProfit(), 
"\n", "      Orders Lot Size       : ", OrderLots(), 
"\n", "      Next Lot Size         : ", LotSize,
"\n");

if (EmailON==1 && TradeAllowed==false) Comment("      OUT OF SESSION - NO TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      EmailON=1; Emails ARE being sent out...!!",
"\n","      Huidige volume currency: ",iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",CurrentSpread, iVolume(Symbol(),0,0),
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "      Balance                : ", AccountBalance(),
"\n", "      Equity                 : ", AccountEquity(), 
"\n", "      Orders Total         : ", OrdersTotal(), 
"\n", "      Total Profit/Loss    : ", AccountProfit(), 
"\n", "      Orders Lot Size       : ", OrderLots(), 
"\n", "      Next Lot Size         : ", LotSize,
"\n");

if (EmailON==1 && TradeAllowed==true) Comment("      IN SESSION - TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      EmailON=1; Emails ARE being sent out...!!",
"\n","      Huidige volume currency: ",iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",CurrentSpread, iVolume(Symbol(),0,0),
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "      Balance                : ", AccountBalance(),
"\n", "      Equity                 : ", AccountEquity(), 
"\n", "      Orders Total         : ", OrdersTotal(), 
"\n", "      Total Profit/Loss    : ", AccountProfit(), 
"\n", "      Orders Lot Size       : ", OrderLots(), 
"\n", "      Next Lot Size         : ", LotSize,
"\n");


if (EmailON==0 && TradeAllowed==false && DayNotAllowed==true) Comment("      OUT OF SESSION - THIS DAY EA IS NOT TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      Website: www.korthoutsoftware.com",
"\n","      EmailON=0; NO emails are being sent out...!!",
"\n","      Huidige volume currency: ", iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",CurrentSpread,
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "      Balance                : ", AccountBalance(),
"\n", "      Equity                 : ", AccountEquity(), 
"\n", "      Orders Total         : ", OrdersTotal(), 
"\n", "      Total Profit/Loss    : ", AccountProfit(), 
"\n", "      Orders Lot Size       : ", OrderLots(), 
"\n", "      Next Lot Size         : ", LotSize,
"\n");



if (EmailON==1 && TradeAllowed==false && DayNotAllowed==true) Comment("      OUT OF SESSION - THIS DAY EA IS NOT TRADING",
"\n","      Deze EA is gemaakt door: JOHAN KORTHOUT",
"\n","      =============================",
"\n","      EmailON=1; Emails ARE being sent out...!!",
"\n","      Huidige volume currency: ",iVolume(Symbol(),0,0),
"\n","      Huidige Spread: ",CurrentSpread, iVolume(Symbol(),0,0),
"\n","      Fast MA setting: ",FastMAPeriod,
"\n","      Slow MA setting: ",SlowMAPeriod,
"\n","      Current server time is ",TimeToStr(TimeCurrent()),
"\n", "      Balance                : ", AccountBalance(),
"\n", "      Equity                 : ", AccountEquity(), 
"\n", "      Orders Total         : ", OrdersTotal(), 
"\n", "      Total Profit/Loss    : ", AccountProfit(), 
"\n", "      Orders Lot Size       : ", OrderLots(), 
"\n", "      Next Lot Size         : ", LotSize,
"\n");


//----
//Hier het timer-gedeelte:
if(UseTimer == true)
  {
    //Convert Start Time 1
    string StartConstant1 = StringConcatenate(StartHour1,":",StartMinute1);
    datetime StartTime1 = StrToTime(StartConstant1);
    
    //Convert start time 2
    string StartConstant2 = StringConcatenate(StartHour2,":",StartMinute2);
    datetime StartTime2 = StrToTime(StartConstant2);
    
    //Convert Start Time 3
    string StartConstant3 = StringConcatenate(StartHour3,":",StartMinute3);
    datetime StartTime3 = StrToTime(StartConstant3);
    
    //Convert start time 4
    string StartConstant4 = StringConcatenate(StartHour4,":",StartMinute4);
    datetime StartTime4 = StrToTime(StartConstant4);
    //Convert End Time
    
    //Convert Start Time 5
    string StartConstant5 = StringConcatenate(StartHour5,":",StartMinute5);
    datetime StartTime5 = StrToTime(StartConstant5);
    
    


    //Convert end time 1:
    string EndConstant1 = StringConcatenate(EndHour1,":",EndMinute1);
    datetime EndTime1 = StrToTime(EndConstant1);
    
    //Convert end time 2:
    string EndConstant2 = StringConcatenate(EndHour2,":",EndMinute2);
    datetime EndTime2 = StrToTime(EndConstant2);
    
    //Convert end time 3:
    string EndConstant3 = StringConcatenate(EndHour3,":",EndMinute3);
    datetime EndTime3 = StrToTime(EndConstant3);
    
    //Convert end time 4:
    string EndConstant4 = StringConcatenate(EndHour4,":",EndMinute4);
    datetime EndTime4 = StrToTime(EndConstant4);
    
    //Convert end time 5:
    string EndConstant5 = StringConcatenate(EndHour5,":",EndMinute5);
    datetime EndTime5 = StrToTime(EndConstant5);
              
    
    //Choose local or server time..
    if(UseLocalTime == true) datetime CurrentTime = TimeLocal();
    if(UseLocalTime == false) CurrentTime = TimeCurrent();
        
    //Check for trade condition..
    if(StartTime1 <=CurrentTime && EndTime1 > CurrentTime || StartTime2 <=CurrentTime && EndTime2 > CurrentTime ||
    StartTime3 <=CurrentTime && EndTime3 > CurrentTime || StartTime4 <=CurrentTime && EndTime4 > CurrentTime || 
    StartTime5 <=CurrentTime && EndTime5 > CurrentTime) 
      {
        TradeAllowed = true;
      }
        else TradeAllowed = false;
    
    TradeAllowed = false;
 

if(DayOfWeek() == 1 && TradeMonday == false)
  {
    TradeAllowed = false;
    DayNotAllowed = True;
  }
if(DayOfWeek() == 2 && TradeTuesday == false)
   {TradeAllowed = false;
    DayNotAllowed = True;
   }
if(DayOfWeek() == 3 && TradeWednesday == false)
  {
    TradeAllowed = false;
    DayNotAllowed = True;
  }
if(DayOfWeek() == 4 && TradeThursday == false)
  {
    TradeAllowed = false;
    DayNotAllowed = True;
  }
if(DayOfWeek() == 5 && TradeFriday == false)
  {
    TradeAllowed = false;
    DayNotAllowed = True;
  }
if(DayOfWeek() == 7 && TradeSunday == false)
  {
    TradeAllowed = false;
    DayNotAllowed = True;
  }
    
// Aanpassen van TradeAllowed adhv NewsTime...
if(NewsTime == true)
  {
    TradeAllowed = false;
  }
    
}
  else TradeAllowed = true;
  
//CONVERT NEWS TIMES...

//Convert News Start Time 1
    string NewsStartConstant1 = StringConcatenate(NewsStartHour1,":",NewsStartMinute1);
    datetime NewsStartTime1 = StrToTime(NewsStartConstant1);

//Convert News Start Time 2
    string NewsStartConstant2 = StringConcatenate(NewsStartHour2,":",NewsStartMinute2);
    datetime NewsStartTime2 = StrToTime(NewsStartConstant2);

//Convert News Start Time 3
    string NewsStartConstant3 = StringConcatenate(NewsStartHour3,":",NewsStartMinute3);
    datetime NewsStartTime3 = StrToTime(NewsStartConstant3);
    
//Convert News Start Time 4
    string NewsStartConstant4 = StringConcatenate(NewsStartHour4,":",NewsStartMinute4);
    datetime NewsStartTime4 = StrToTime(NewsStartConstant4);

//Convert News Start Time 5
    string NewsStartConstant5 = StringConcatenate(NewsStartHour5,":",NewsStartMinute5);
    datetime NewsStartTime5 = StrToTime(NewsStartConstant5);


//CONVERT NEWS END TIMES:

//Convert News End Time 1
    string NewsEndConstant1 = StringConcatenate(NewsEndHour1,":",NewsEndMinute1);
    datetime NewsEndTime1 = StrToTime(NewsEndConstant1);

//Convert News Start Time 2
        string NewsEndConstant2 = StringConcatenate(NewsEndHour2,":",NewsEndMinute2);
    datetime NewsEndTime2 = StrToTime(NewsEndConstant2);

//Convert News Start Time 3
        string NewsEndConstant3 = StringConcatenate(NewsEndHour3,":",NewsEndMinute3);
    datetime NewsEndTime3 = StrToTime(NewsEndConstant3);
    
//Convert News Start Time 4
        string NewsEndConstant4 = StringConcatenate(NewsEndHour4,":",NewsEndMinute4);
    datetime NewsEndTime4 = StrToTime(NewsEndConstant4);

//Convert News Start Time 5
        string NewsEndConstant5 = StringConcatenate(NewsEndHour5,":",NewsEndMinute5);
    datetime NewsEndTime5 = StrToTime(NewsEndConstant5);

                                        
//News time bepalen en TradeAllowed evt aanpassen
 if(NewsStartTime1 <=CurrentTime && NewsEndTime1 > CurrentTime || NewsStartTime2 <=CurrentTime && NewsEndTime2 > CurrentTime ||
  NewsStartTime3 <=CurrentTime && NewsEndTime3 > CurrentTime || NewsStartTime4 <=CurrentTime && NewsEndTime4 > CurrentTime ||
  NewsStartTime5 <=CurrentTime && NewsEndTime5 > CurrentTime) 
  {
    NewsTime = true;
  }
else NewsTime = false;
     

  
//Sluiten van alle openstaande orders als TradeAllowed false is...
if(TradeAllowed == false && CloseAllTheOrders ==true)
  {
   if (TotalOrderCount(Symbol(),MagicNumber) > 0)
    {
   CloseAllBuyOrders(Symbol(),MagicNumber,Slippage);
   CloseAllSellOrders(Symbol(),MagicNumber,Slippage);
   CloseAllBuyStopOrders(Symbol(),MagicNumber);
   CloseAllSellStopOrders(Symbol(),MagicNumber);
   CloseAllBuyLimitOrders(Symbol(),MagicNumber);
   CloseAllSellLimitOrders(Symbol(),MagicNumber);
    }
  }

//Execute on Bar Open 
if(CheckOncePerBar == true) 
  {
    int BarShift = 1;
    if(CurrentTimeStamp != Time[0])
      {
        CurrentTimeStamp = Time[0];
        bool NewBar = true;
      }
    else NewBar = false;
  }
 else
   {
     NewBar = true;
     BarShift = 0;
   }
 
 
 //Moving Averages
 double FastMA = iMA(NULL,0,FastMAPeriod,0,0,0,BarShift);
 double SlowMA = iMA(NULL,0,SlowMAPeriod,0,0,0,BarShift);
 
 double LastFastMA = iMA(NULL,0,FastMAPeriod,0,0,0,BarShift+1);
 double LastSlowMA = iMA(NULL,0,SlowMAPeriod,0,0,0,BarShift+1);

// Bepalen van minvolume1 zodat de trade rekening houdt met het min volume (indien ingesteld)...
//(word uitgerekend in de include -file waar de functie zich bevindt...
DetermineMinVolume();

 //Sluiten van alle sell orders bij buy signaal..
 if(FastMA > SlowMA && LastFastMA <= LastSlowMA
   && BuyMarketCount(Symbol(),MagicNumber) == 0 && TradeAllowed == true
      && iVolume(Symbol(),0,0) >= minvolume1)
     {
       //Close sell OrderSelect
       if(SellMarketCount(Symbol(),MagicNumber) > 0)
         {
       CloseAllSellOrders(Symbol(),MagicNumber,Slippage);
         }     
 //Openen van nieuwe buy order...
BuyTicket = OpenBuyOrder(Symbol(),LotSize,UseSlippage,MagicNumber);
if (SoundON==1) Alert("AVMA CrossOver BUY signal at Ask=",Ask,", Bid=",Bid,", Time=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period(),"Volume: ",iVolume(Symbol(),0,0));
if (EmailON==1) SendMail("AVMA CrossOver BUY signal alert","AVMA CrossOver BUY Order Opened at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
//Order modification...
if(BuyTicket > 0 && (StopLoss > 0 || TakeProfit > 0))
  {
    OrderSelect(BuyTicket,SELECT_BY_TICKET);
    double OpenPrice = OrderOpenPrice();
    
    //Calculate and verify stop loss and take profit..
    double BuyStopLoss = CalcBuyStopLoss(Symbol(),StopLoss,OpenPrice);
    if(BuyStopLoss > 0)
    {
        BuyStopLoss = AdjustBelowStopLevel(Symbol(),BuyStopLoss,5);
      }
      
      double BuyTakeProfit = CalcBuyTakeProfit(Symbol(),TakeProfit,OpenPrice);
      if(BuyTakeProfit > 0)
        {
          BuyTakeProfit = AdjustAboveStopLevel(Symbol(),BuyTakeProfit,5);
        }
      //Add stop loss and take profit...
      AddStopProfit(BuyTicket,BuyStopLoss,BuyTakeProfit);
    }
  }

//Sell order - Sluiten buy orders bij sell signaal...
if(FastMA < SlowMA && LastFastMA >= LastSlowMA
  && SellMarketCount(Symbol(),MagicNumber) == 0 && TradeAllowed == true
     && iVolume(Symbol(),0,0) >= minvolume1)
    {
      if(BuyMarketCount(Symbol(),MagicNumber) > 0)
        {
          CloseAllBuyOrders(Symbol(),MagicNumber,Slippage);
        }

      SellTicket = OpenSellOrder(Symbol(),LotSize,UseSlippage,MagicNumber);
      if (SoundON==1) Alert("AVMA CrossOver SELL signal at Ask=",Ask,", Bid=",Bid,", Date=",TimeToStr(CurTime(),TIME_DATE)," ",TimeHour(CurTime()),":",TimeMinute(CurTime())," Symbol=",Symbol()," Period=",Period(),"Volume: ",iVolume(Symbol(),0,0));
      if (EmailON==1) SendMail("AVMA CrossOver SELL signal alert","AVMA CrossOver SELL Order Opened at Ask="+DoubleToStr(Ask,4)+", Bid="+DoubleToStr(Bid,4)+", Date="+TimeToStr(CurTime(),TIME_DATE)+" "+TimeHour(CurTime())+":"+TimeMinute(CurTime())+" Symbol="+Symbol()+" Period="+Period());
      if(SellTicket > 0 && (StopLoss > 0 || TakeProfit > 0))
        {
          OrderSelect(SellTicket,SELECT_BY_TICKET);
          OpenPrice = OrderOpenPrice();
          
          double SellStopLoss = CalcSellStopLoss(Symbol(),StopLoss,OpenPrice);
          if(SellStopLoss > 0)
           {
             SellStopLoss = AdjustAboveStopLevel(Symbol(),SellStopLoss,5);
           }
           
       double SellTakeProfit = CalcSellTakeProfit(Symbol(),TakeProfit,OpenPrice);
       if(SellTakeProfit > 0)
         {
           SellTakeProfit = AdjustBelowStopLevel(Symbol(),SellTakeProfit,5);
         }
       AddStopProfit(SellTicket,SellStopLoss,SellTakeProfit);
     }
   }
   
   //Adjust trailing stops...
   if(BuyMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
     {
       BuyTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);
     }
   if(SellMarketCount(Symbol(),MagicNumber) > 0 && TrailingStop > 0)
     {
       SellTrailingStop(Symbol(),TrailingStop,MinimumProfit,MagicNumber);
     }
   return(0);     
//----
  }
double DetermineMinVolume()
 {
   if (Period() == 1 || Period() == 240 || Period() == 1440)
    {
       Alert("This EA uses TimeFrame 5, 15, 30 or 60 min.");    
         
    }
   if (Period() == 5 && VolumeFilter == true) minvolume1 = 70;
   if (Period() == 15 && VolumeFilter == true) minvolume1 = 190;
   if (Period() == 30 && VolumeFilter == true) minvolume1 = 360;
   if (Period() == 60 && VolumeFilter == true) minvolume1 = 720;
   if (VolumeFilter == false) minvolume1 = 0;
   if (ManualVolumeFilterON == true && VolumeFilter == true) minvolume1 = MinimalVolume;
   return(minvolume1);
 }

//+------------------------------------------------------------------+